mainApp/urls.py
from django.contrib import admin
from rest_framework_simplejwt import views as jwt_views
from django.urls import path, include

urlpatterns = [
    path('admin/', admin.site.urls),
    path('', include('restaurant.urls')),
    path('api-auth/', include('rest_framework.urls')),
    path('api/token/', jwt_views.TokenObtainPairView.as_view(), name='token_obtain_pair'),
    path('api/token/refresh/', jwt_views.TokenRefreshView.as_view(), name='token_refresh'),
]

restaurant/urls.py
from django.urls import path, include
from rest_framework import routers

from restaurant.views import CreateClient, ListClient, UpdateClient, DeleteClient, HomePageView, CreateWaiter, \
    ListWaiter, DeleteWaiter, CreateTypeProduct, ListTypeProduct, UpdateTypeProduct, DeleteTypeProduct, CreateProducts, \
    ListProducts, DeleteProducts, UpdateProducts, CreateTable, ListTable, UpdateTable, DeleteTable, CreateInvoice, \
    ListInvoice, UpdateInvoice, DeleteInvoice, CreateOrder, ListOrder, UpdateOrder, DeleteOrder, UpdateWaiter, \
    DetailViewInvoice, ClientViewSet, WaiterViewSet, TypeProductViewSet, ProductsViewSet, TableViewSet, InvoiceViewSet, \
    OrderViewSet

app_name = 'restaurant'

router = routers.DefaultRouter()
router.register(r'client', ClientViewSet)
router.register(r'waiter', WaiterViewSet)
router.register(r'type products', TypeProductViewSet)
router.register(r'products', ProductsViewSet)
router.register(r'table', TableViewSet)
router.register(r'invoice', InvoiceViewSet)
router.register(r'order', OrderViewSet)


urlpatterns = [
    path('', HomePageView.as_view(), name='home'),

    path('serializer/', include(router.urls), name='api'),

    # ---------------------------Urls Client--------------------------------
    path('create-client/', CreateClient.as_view(), name='create_client'),
    path('list-client/', ListClient.as_view(), name='list_client'),
    path('update-client/<int:pk>/', UpdateClient.as_view(), name='update_client'),
    path('delete-client/<int:pk>', DeleteClient.as_view(), name='delete_client'),

    # ---------------------------Urls Waiter--------------------------------
    path('create-waiter/', CreateWaiter.as_view(), name='create_waiter'),
    path('list-waiter/', ListWaiter.as_view(), name='list_waiter'),
    path('update-waiter/<int:pk>/', UpdateWaiter.as_view(), name='update_waiter'),
    path('delete-waiter/<int:pk>/', DeleteWaiter.as_view(), name='delete_waiter'),

    # ---------------------------Urls TypeProduct--------------------------------
    path('create-type/', CreateTypeProduct.as_view(), name='create_type'),
    path('list-type/', ListTypeProduct.as_view(), name='list_type'),
    path('update-type/<int:pk>/', UpdateTypeProduct.as_view(), name='update_type'),
    path('delete-type/<int:pk>/', DeleteTypeProduct.as_view(), name='delete_type'),

    # ---------------------------Urls Products--------------------------------
    path('create-products/', CreateProducts.as_view(), name='create_products'),
    path('list-products/', ListProducts.as_view(), name='list_products'),
    path('update-products/<int:pk>/', UpdateProducts.as_view(), name='update_products'),
    path('delete-products/<int:pk>/', DeleteProducts.as_view(), name='delete_products'),

    # ---------------------------Urls Table--------------------------------
    path('create-table/', CreateTable.as_view(), name='create_table'),
    path('list-table/', ListTable.as_view(), name='list_table'),
    path('update-table/<int:pk>/', UpdateTable.as_view(), name='update_table'),
    path('delete-table/<int:pk>/', DeleteTable.as_view(), name='delete_table'),

    # ---------------------------Urls Invoice--------------------------------
    path('create-invoice/', CreateInvoice.as_view(), name='create_invoice'),
    path('list-invoice/', ListInvoice.as_view(), name='list_invoice'),
    path('update-invoice/<int:pk>/', UpdateInvoice.as_view(), name='update_invoice'),
    path('delete-invoice/<int:pk>/', DeleteInvoice.as_view(), name='delete_invoice'),
    path('<int:pk>/', DetailViewInvoice.as_view(), name='detail_invoice'),

    # ---------------------------Urls Order--------------------------------
    path('create-order/', CreateOrder.as_view(), name='create_order'),
    path('list-order/', ListOrder.as_view(), name='list_order'),
    path('update-order/<int:pk>/', UpdateOrder.as_view(), name="update_order"),
    path('delete-order/<int:pk>/', DeleteOrder.as_view(), name="delete_order"),
]

templates/invoice/create_invoice.html
{% extends 'base.html' %}
{% block title %} Create Invoice {% endblock %}
{% load add_attr %}
{% block content %}
    <form method="POST" class="container mt-5">
        {% csrf_token %}
        <h1>Register Invoice</h1>
        <div class="row mb-3 mt-4 ">
            <label for="inputId_client" class="col-sm-2 col-form-label">Id Client</label>
            <div class="col-sm-10">
                {{ form.id_client | add_attr:"class:form-control, type:text, id:inputId_client" }}
            </div>
        </div>
        <div class="row mb-3">
            <label for="inputTd_waiter" class="col-sm-2 col-form-label">Id Waiter</label>
            <div class="col-sm-10">
                {{ form.id_waiter | add_attr:"class:form-control, type:text, id:inputLastName" }}
            </div>
        </div>
        <div class="row mb-3">
            <label for="inputId_table" class="col-sm-2 col-form-label">Id Table</label>
            <div class="col-sm-10">
                {{ form.id_table | add_attr:"class:form-control, type:text, id:inputId_table" }}
            </div>
        </div>
        <div>
            <input class="btn btn-success" type="submit" value="Save"/>
            <a href="{{ request.META.HTTP_REFERER }}" class="btn btn-secondary" tabindex="-1" role="button">Cancel</a>
        </div>
    </form>
{% endblock %}

templates/invoice/delete_invoice.html
{% extends 'base.html' %}
{% block title %} Delete Order {% endblock %}
{% load add_attr %}
{% block content %}
    <form method="POST" class="container mt-5">
        {% csrf_token %}
        <h1 class="text-center mb-3">Delete Order</h1>
        <div class="d-flex position-relative shadow p-3 mb-5 bg-body rounded">
            <img src="/static/images/danger.svg" class="flex-shrink-0 me-3 w-25 p-3" alt="Danger">
            <div>
                <br/>
                <h5 class="mt-0">Are you Sure?</h5>
                <p>
                    <span>Do you want to delete this client?</span>
                </p>
                <div class="mb-2 mt-4">
                    {{ form.delete_invoice | add_attr:"class:form-check-input, type:checkbox, id:delete_client" }}
                    <label class="form-check-label" for="delete_client">
                        Checked for delete
                    </label>
                </div>
                <div>
                    <input class="btn btn-success" type="submit" value="Delete" />
                    <a href="{{ view.get_success_url }}" class="btn btn-secondary">Cancel</a>
                </div>
            </div>
        </div>
    </form>
{% endblock %}

templates/invoice/invoice.html
{% extends 'base.html' %}
{% block title %} Detail Invoice{% endblock %}
{% block css-invoice %}
    <link href="../../static/css/style_invoice.css" rel="stylesheet">
{% endblock %}
{% block content %}

    <div class="container bootstrap snippets bootdeys">
        <div class="row">
            <div class="col-sm-12">
                <div class="panel panel-default invoice" id="invoice">
                    <div class="panel-body">
                        <div class="row">
                            <div class="col-sm-6 top-left">
                                <i class="fas fa-door-open"></i>
                            </div>

                            <div class="col-sm-6 top-right mt-1">
                                <h3 class="marginright">INVOICE-{{ obj.id }}</h3>
                                <span class="marginright">{{ obj.date }}</span>
                            </div>
                        </div>
                        <p>Di Florencia</p>
                        <hr>
                        <div class="d-flex justify-content-between">
                            <!-- Detail Restaurant - Client - Invoice -->
                            <div class="col-xs-4 from">
                                <p class="lead marginbottom ">From : Di Florencia</p>
                                <p>350 Rhode Island Street</p>
                                <p>Suite 240, San Francisco</p>
                                <p>California, 94103</p>
                                <p>Phone: 415-767-3600</p>
                                <p>Email: contact@dynofy.com</p>
                            </div>

                            <div class="col-xs-4 to">
                                <p class="lead ">To : {{ obj.id_client.name }}</p>
                                <p>425 Market Street</p>
                                <p>Suite 2200, San Francisco</p>
                                <p>California, 94105</p>
                                <p>Phone: 415-676-3600</p>
                                <p>Email: john@doe.com</p>
                            </div>

                            <div class="col-xs-4 text-right payment-details">
                                <p class="lead marginbottom payment-info">Invoice details</p>
                                <p>Date: {{ obj.date }}</p>
                                <p>Table: {{ obj.id_table.code }}</p>
                                <p>Waiter: {{ obj.id_waiter.name}} {{ obj.id_waiter.last_name1 }}</p>
                                <p>Total Amount: $1019</p>
                            </div>
                        </div>
                        <!-- ----------------- Detail Invoice ------------------- -->
                        <div class="row table-row">
                            <table class="table table-striped">
                                <thead>
                                <tr>
                                    <th class="text-center" style="width:5%">Item</th>
                                    <th style="width:50%">Product</th>
                                    <th class="text-right" style="width:15%">Quantity</th>
                                    <th class="text-right" style="width:15%">Unit Price</th>
                                    <th class="text-right" style="width:15%">Total Price</th>
                                </tr>
                                </thead>
                                <tbody>
                                {% for order in obj.orders.reverse %}
                                <tr>
                                    <td class="text-center">{{ fooloop.counter }}</td>
                                    <td>{{ order.id_products.name }}</td>
                                    <td class="text-right">{{ order.quantity }}</td>
                                    <td class="text-right">{{ order.id_products.price }}</td>
                                    <td class="text-right">{{ order.sub_price }}</td>
                                </tr>
                                {% endfor %}
                                </tbody>
                            </table>
                        </div>

                        <div class="d-flex justify-content-around">
                            <div class="col-xs-6 margintop">
                                <p class="lead marginbottom">THANK YOU!</p>
                                <button onclick="window.print()" class="btn btn-secondary" id="invoice-print"><i class="fa fa-print"></i> Print
                                    Invoice
                                </button>
                                <button class="btn btn-success"><i class="fa fa-envelope-o"></i> Mail Invoice</button>
                            </div>
                            <div class="col-xs-6 text-right pull-right invoice-total">
                                <p>Subtotal : $1019</p>
                                <p>Discount (10%) : $101 </p>
                                <p>VAT (8%) : $73 </p>
                                <p>Total: {{ order.total_invoice }} </p>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </div>
{% endblock %}

<!--
<body>
     <input type = "button" value = "Imprimir esta página" οnclick = "printpage ()" />

  startprint
     <div id = "printContent"> Imprimir contenido </div>
  endprint

  <script>
    function printpage() {
             let oldStr = window.document.body.innerHTML; // Obtener el contenido del cuerpo
             let start = "<! - startprint ->"; // Iniciar la impresión del logotipo, 17 caracteres
             let end = "<! - endprint ->"; // fin de imprimir logo
             let newStr = oldStr.substr (oldStr.indexOf (start) + 17); // interceptar el contenido después de comenzar a imprimir el logotipo
             newStr = newStr.substring (0, newStr.indexOf (end)); // Interceptar el contenido entre la marca de inicio de impresión y la marca de finalización de impresión
             window.document.body.innerHTML = newStr; // Asignar el contenido especificado que debe imprimirse en el cuerpo
             window.print (); // Llame a la función de impresión del navegador para imprimir el área especificada
             window.document.body.innerHTML = oldStr; // reemplaza el cuerpo con el contenido original
    }
  </script>
</body>
-->

templates/invoice/list_invoice.html
{% extends 'base.html' %}
{% block title %}List Invoice{% endblock %}
{% block content %}
    <div class="container">
    <h1 class="text-center mt-4">Invoice List</h1>
        <table class="table table-striped">
            <thead>
            <tr>
                <th scope="col">#</th>
                <th scope="col">Client</th>
                <th scope="col">Waiter</th>
                <th scope="col">Table</th>
                <th scope="col">Date</th>
                <th scope="col">Actions</th>
            </tr>
            </thead>
            <tbody>
            {% for invoice in object_list %}
            <tr>
                <th scope="row">{{ forloop.counter }}</th>
                <td>{{ invoice.id_client }}</td>
                <td>{{ invoice.id_waiter.name }}</td>
                <td>{{ invoice.id_table.code }}</td>
                <td>{{ invoice.date }}</td>
                <td><a href="{% url 'restaurant:update_invoice' invoice.id %}"><i class="fas fa-edit mx-2"></i></a>
                    | <a href="{% url 'restaurant:detail_invoice' invoice.id %}" class="link-success mx-2"><i class="far fa-eye"></i></a>
                    | <a href="{% url 'restaurant:delete_invoice' invoice.id %}" class="link-danger mx-2"><i class="fas fa-trash"></i></a>
                </td>
            </tr>
            {% endfor%}
            </tbody>
        </table>

    </div>
{% endblock %}

templates/invoice/update_invoice.html
{% extends 'base.html' %}
{% block title %} Update Invoice {% endblock %}
{% load add_attr %}
{% block content %}
    <form method="POST" class="container mt-5">
        {% csrf_token %}
        <h1>Update Invoice</h1>
        <div class="row mb-3 mt-4 ">
            <label for="inputId_client" class="col-sm-2 col-form-label">Id Client</label>
            <div class="col-sm-10">
                {{ form.id_client | add_attr:"class:form-control, type:text, id:inputId_client" }}
            </div>
        </div>
        <div class="row mb-3">
            <label for="inputTd_waiter" class="col-sm-2 col-form-label">Id Waiter</label>
            <div class="col-sm-10">
                {{ form.id_waiter | add_attr:"class:form-control, type:text, id:inputLastName" }}
            </div>
        </div>
        <div class="row mb-3">
            <label for="inputId_table" class="col-sm-2 col-form-label">Id Table</label>
            <div class="col-sm-10">
                {{ form.id_table | add_attr:"class:form-control, type:text, id:inputId_table" }}
            </div>
        </div>
        <div>
            <input class="btn btn-success" type="submit" value="Save"/>
            <a href="{{ view.get_success_url }}" class="btn btn-secondary">Cancel</a>
        </div>
    </form>
{% endblock %}